﻿IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[FNS_Localized_GetLocalizedValue]') AND type in (N'P', N'PC'))
DROP PROCEDURE [FNS_Localized_GetLocalizedValue]
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[FNS_Localized_GetLocalizedValue]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[FNS_Localized_GetLocalizedValue]
GO
/****** Object:  StoredProcedure [FNS_Category_GetAllCategories]    Script Date: 04/12/2013 17:19:27 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[FNS_Localized_GetLocalizedValue]
(
	@languageId int,	--Language identifier
	@entityId	int,	--Entity identifier
	@localeKeyGroup NVARCHAR(MAX), --Locale key group
	@localeKey		NVARCHAR(MAX) --Locale key
)
AS
BEGIN
SET NOCOUNT ON
select Lp.* 
from LocalizedProperty Lp WITH (NOLOCK)
where Lp.LanguageId = @languageId and 
     Lp.EntityId = @entityId and
     Lp.LocaleKeyGroup =@localeKeyGroup and 
     Lp.LocaleKey =@localeKey
END
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[FNS_Localized_GetEntityIdByLocalizedValue]') AND type in (N'P', N'PC'))
DROP PROCEDURE [FNS_Localized_GetEntityIdByLocalizedValue]
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[FNS_Localized_GetLocalizedProperties]') AND type in (N'P', N'PC'))
DROP PROCEDURE [FNS_Localized_GetLocalizedProperties]
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[FNS_Localized_GetEntityIdByLocalizedValue]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[FNS_Localized_GetEntityIdByLocalizedValue]
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[FNS_Localized_GetLocalizedProperties]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[FNS_Localized_GetLocalizedProperties]
GO
IF  not EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[LocalizedProperty]') AND name = N'IX_FNS_LocalizedProperty_EntityId')
CREATE NONCLUSTERED INDEX IX_FNS_LocalizedProperty_EntityId ON LocalizedProperty
	(
	EntityId
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO