﻿IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[FNS_PriceCalculation_GetAllowedDiscounts]') AND type in (N'P', N'PC'))
DROP PROCEDURE [FNS_PriceCalculation_GetAllowedDiscounts]
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[FNS_PriceCalculation_GetAllowedDiscounts]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[FNS_PriceCalculation_GetAllowedDiscounts]
GO
/****** Object:  StoredProcedure [FNS_PriceCalculation_GetAllowedDiscounts]    Script Date: 11/17/2013 00:19:00 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[FNS_PriceCalculation_GetAllowedDiscounts]
(
	@productId int, --Product identifier,
	@customerId int=0, --customer identifier
	@StoreId int=0  -- Store mapping
)
AS
BEGIN
SET NOCOUNT ON
create table #FilteredCustomerRoleIds (CustomerRoleId int NOT NULL)

insert into #FilteredCustomerRoleIds (CustomerRoleId)
select crm.CustomerRole_Id as CustomerRoleId
from Customer_CustomerRole_Mapping crm  WITH (NOLOCK) 
where crm.Customer_Id=@customerId

create table #tmpCategory (Id int)
--D.DiscountTypeId =5 --DiscountType.AssignedToCategories
if exists (select Id from Discount D WITH (NOLOCK) where D.DiscountTypeId =5)
begin
	insert into #tmpCategory (Id)
	select C.Id
	from Product_Category_Mapping Pc  WITH (NOLOCK),Category C  WITH (NOLOCK)
	where Pc.CategoryId=C.Id 
		and  Pc.ProductId=@productId
		and C.Deleted=0
		and C.Published=1
		and (C.SubjectToAcl = 0 OR EXISTS (
						SELECT 1 FROM #FilteredCustomerRoleIds [fcr]
							WHERE
								[fcr].CustomerRoleId IN (
									SELECT [acl].CustomerRoleId
									FROM [AclRecord] acl  WITH (NOLOCK)
									WHERE [acl].EntityId = C.Id AND [acl].EntityName = 'Category'
								)
							))
		and (@StoreId=0 or C.LimitedToStores=0 or Exists(select Top 1 Id from StoreMapping sm   WITH (NOLOCK)
			where sm.EntityName = 'Category' and sm.StoreId=@StoreId and sm.EntityId=C.Id))
end

create table #tmpManufacturer (Id int)
--D.DiscountTypeId =6 --DiscountType.AssignedToManufacturers
if exists (select Id from Discount D WITH (NOLOCK) where D.DiscountTypeId =6)
begin
	insert into #tmpManufacturer (Id)
	select M.Id
	from Product_Manufacturer_Mapping Pm  WITH (NOLOCK),Manufacturer M  WITH (NOLOCK)
	where Pm.ManufacturerId=M.Id 
		and  Pm.ProductId=@productId
		and M.Deleted=0
		and M.Published=1
		and (M.SubjectToAcl = 0 OR EXISTS (
						SELECT 1 FROM #FilteredCustomerRoleIds [fcr]
							WHERE
								[fcr].CustomerRoleId IN (
									SELECT [acl].CustomerRoleId
									FROM [AclRecord] acl  WITH (NOLOCK)
									WHERE [acl].EntityId = M.Id AND [acl].EntityName = 'Manufacturer'
								)
							))
		and (@StoreId=0 or M.LimitedToStores=0 or Exists(select Top 1 Id from StoreMapping sm   WITH (NOLOCK)
			where sm.EntityName = 'Manufacturer' and sm.StoreId=@StoreId and sm.EntityId=M.Id))
end

create table #tmpDiscount 
(
	Id int NOT NULL,	
	StartDateUtc datetime NULL,
	EndDateUtc datetime NULL,
	RequiresCouponCode bit NOT NULL,
	CouponCode nvarchar(100) NULL,
	DiscountLimitationId int NOT NULL,
	LimitationTimes int NOT NULL,
	)
insert into #tmpDiscount (Id,StartDateUtc,EndDateUtc,RequiresCouponCode,CouponCode,DiscountLimitationId,LimitationTimes)
select Id,StartDateUtc,EndDateUtc,RequiresCouponCode,CouponCode,DiscountLimitationId,LimitationTimes
from Discount D WITH (NOLOCK)
where (D.Id in (select DP.Discount_Id from Discount_AppliedToProducts DP WITH (NOLOCK) where DP.Product_Id=@productId)
		and D.DiscountTypeId =2 --DiscountType.AssignedToSkus
		)	
	or (D.Id in (select DC.Discount_Id from Discount_AppliedToCategories DC WITH (NOLOCK) 
		where DC.Category_Id in (select Id from #tmpCategory))
		and D.DiscountTypeId =5 --DiscountType.AssignedToCategories
		)
	or (D.Id in (select DC.Discount_Id from Discount_AppliedToManufacturers DC WITH (NOLOCK) 
		where DC.Manufacturer_Id in (select Id from #tmpManufacturer))
		and D.DiscountTypeId =6 --DiscountType.AssignedToManufacturers
		)
		
drop table #tmpCategory
drop table #tmpManufacturer

	/*
    check coupon code
	delete from #tmpDiscount 
	where RequiresCouponCode=1 and 
			(CouponCode is null or CouponCode!=@couponCodeToValidate)
	*/

    /*check date range*/
	delete from #tmpDiscount 
	where (StartDateUtc is not null and StartDateUtc>GETUTCDATE()) or (EndDateUtc is not null and EndDateUtc<GETUTCDATE())

	
	/*DiscountLimitationId=15  DiscountLimitationType.NTimesOnly*/
	if exists(select D.Id from #tmpDiscount D where D.DiscountLimitationId=15)
	begin	
		create table #tmpDiscountUsageHistory15 (DiscountId int NOT NULL, cnt int)
		insert into #tmpDiscountUsageHistory15 (DiscountId,cnt)
		select DI.DiscountId,COUNT(*) as cnt 
		from DiscountUsageHistory DI WITH (NOLOCK)
		where DI.DiscountId in (select D.Id from #tmpDiscount D where D.DiscountLimitationId=15)
		group By DI.DiscountId
		
		delete #tmpDiscount
		from #tmpDiscount D,#tmpDiscountUsageHistory15 DI
		where D.Id=DI.DiscountId and D.LimitationTimes<=DI.cnt
		
		drop table #tmpDiscountUsageHistory15			
	end

	/*DiscountLimitationId=25  DiscountLimitationType.NTimesPerCustomer*/
	if exists(select D.Id from #tmpDiscount D where D.DiscountLimitationId=25)
	begin	
		declare @IsGuest bit
		set @IsGuest=0
		
		if exists(select crm.CustomerRoleId 
				from #FilteredCustomerRoleIds crm  WITH (NOLOCK) 
				where CustomerRoleId in (
							SELECT [Id]
							FROM [CustomerRole] CR
							where CR.SystemName='Guests'))
		begin
			set @IsGuest=1
		end
		if @customerId=0
		begin
			set @IsGuest=1
		end
		
		if @IsGuest=0
		begin
			create table #tmpDiscountUsageHistory25 (DiscountId int NOT NULL, cnt int)
			insert into #tmpDiscountUsageHistory25 (DiscountId,cnt)
			select DI.DiscountId,COUNT(*) as cnt 
			from DiscountUsageHistory DI WITH (NOLOCK)
			where DI.DiscountId in (select D.Id from #tmpDiscount D where D.DiscountLimitationId=25)
				
			group By DI.DiscountId
			
			delete #tmpDiscount
			from #tmpDiscount D,#tmpDiscountUsageHistory25 DI
			where D.Id=DI.DiscountId and D.LimitationTimes<=DI.cnt
			
			drop table #tmpDiscountUsageHistory25		
		end
	end

select * 
from Discount WITH (NOLOCK)
where Id in (select Id from #tmpDiscount)
/*
select * from DiscountRequirement DR WITH (NOLOCK) 
where DR.DiscountId in (select Id from #tmpDiscount)
order by DR.DiscountId
*/
drop table #tmpDiscount
END
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[FNS_PriceCalculation_VerifySpecialOffer]') AND type in (N'P', N'PC'))
DROP PROCEDURE [FNS_PriceCalculation_VerifySpecialOffer]
GO
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[FNS_PriceCalculation_VerifySpecialOffer]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[FNS_PriceCalculation_VerifySpecialOffer]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[FNS_PriceCalculation_VerifySpecialOffer]
(
	@CustomerId int, -- Customer identifier
	@StoreId int, -- Store identifier
	@SpecialofferId int, -- StoreOffer identifier
	@ShoppingCartTypeId int, -- ShoppingCartTypeId identifier
	@IsOffer bit OUT -- return parameter isOffer = 1 - is offer price 
)
AS
BEGIN
SET NOCOUNT ON
set @IsOffer=0
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'FNS_SpecialOffer_Product') AND type in (N'U')) 
begin
	create table #tmpShoppingCartItem(ProductId int,Quantity int)

	insert into #tmpShoppingCartItem (ProductId,Quantity)
	select si.ProductId,si.Quantity 
	from ShoppingCartItem si with (NOLOCK)
	where si.CustomerId=@CustomerId and si.StoreId=@StoreId and si.ShoppingCartTypeId=@ShoppingCartTypeId

	create table #tmpFNS_SpecialOffer_Product(ProductId int,Quantity int)
	insert into #tmpFNS_SpecialOffer_Product (ProductId,Quantity)
	select sp.ProductId,sp.Quantity
	from FNS_SpecialOffer s with (nolock),FNS_SpecialOffer_Product sp with (nolock)
	where s.Id=@SpecialofferId and s.StoreId=@StoreId
		and s.Deleted=0 
		and (s.EndDateUtc is null or s.EndDateUtc>GETUTCDATE())
		and s.SpecialOfferStatusId=10 --Actively
		and s.Id=sp.SpecialOfferId

	set @IsOffer=1		
	if (exists (select *
			from #tmpFNS_SpecialOffer_Product sp left join #tmpShoppingCartItem si on sp.ProductId=si.ProductId
			where sp.Quantity>ISNULL(si.Quantity,0)))
		set @IsOffer=0		
	
	drop table #tmpShoppingCartItem	
	drop table #tmpFNS_SpecialOffer_Product
end	

end
GO
